/************************************************************************/
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/************************************************************************/

 // sample to create and delete Text Search Index
 /*
 * Filename       : TCreateDelIndexTS.cpp
 * Description    : createIndex, deleteIndex
 *
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstantDL.h>
#include <DKDatastoreTS.hpp>
#include <DKException.hpp>
#include <DKString.hpp>
#include <DKDatastoreDefTS.hpp>
#include <DKDatastoreAdminTS.hpp>
#include <DKSearchIndexDefTS.hpp>

void main(int argc, char *argv[])
{
   cout << "begin..." << endl;
    //-------------------------------------------------------------- 
    // Checking for input parameters
    //--------------------------------------------------------------   
    if (argc < 3)
    {
     cout<<"Usage: "<<endl;
     cout<<"  TCreateDelIndexTS <srchSrv> <srchIndex>" << endl;
     return;
    }
    // ### get input parameters
    DKString srchSrv = DKString(argv[1]);
    DKString srchIndex = DKString(argv[2]);
    DKDatastoreTS dsTS; // must be outside try/catch block

   try {
      
      DKDatastoreDefTS* dsDef = 0;
      DKDatastoreAdminTS* dsAdmin = 0;
      DKString strIndexName;
      DKSearchIndexDefTS *pIndxEnt = 0;
      DKSearchIndexDefTS *pIndxEntOut = 0;
      long _indexType = 0;
      DKString strIndexType;
      long _indexADD = 0;
      DKString strIndexADD;
      DKString strDefaultDir;
      DKString strIndexFileDir;
      DKString strWorkFileDir;
      long i = 0;
      DKAny a;
      cout << "connecting to datastore" << endl;
      dsTS.connect(srchSrv,"","");
      cout << "datastore connected " << srchSrv << endl;
      pIndxEnt = new DKSearchIndexDefTS(&dsTS);
      dsDef = (DKDatastoreDefTS*)dsTS.datastoreDef();
      dsAdmin = (DKDatastoreAdminTS*)dsDef->datastoreAdmin();
      cout << " create index " << srchIndex << endl;
      pIndxEnt->setName(srchIndex);
      pIndxEnt->setIndexType(DK_TS_INDEX_TYPE_PRECISE);
      pIndxEnt->setIndexCCSID(DK_TS_CCSID_00850);
      pIndxEnt->setLibraryId("LIBSUM");
      pIndxEnt->setLibraryClientServices("IMLLSCDL");
      pIndxEnt->setLibraryServerServices("IMLLSSDL");
      strDefaultDir = "e:\\tsindex\\";
      strIndexFileDir = strDefaultDir + "index\\";
      strIndexFileDir = strIndexFileDir + srchIndex;
      strWorkFileDir = strDefaultDir + "work\\";
      strWorkFileDir = strWorkFileDir + srchIndex;
      pIndxEnt->setIndexDataArea(strIndexFileDir);
      pIndxEnt->setIndexWorkArea(strWorkFileDir);
      dsDef->add((dkEntityDef*)pIndxEnt);
      cout << " created index " << srchIndex << endl;
      if (pIndxEnt != 0)
       delete pIndxEnt;
      //************************** get index Ent ****************************
      strIndexName = srchIndex;
      cout << " get index Ent " << strIndexName << endl;
      pIndxEntOut = (DKSearchIndexDefTS*)dsDef->getEntity(strIndexName);
      cout << "*Index name " << pIndxEntOut->getName() << endl;
      _indexType = pIndxEntOut->getIndexType();
      if (_indexType == DK_TS_INDEX_TYPE_LINGUISTIC)
      {
     	 strIndexType = "LINGUISTIC";
      }
      else if (_indexType == DK_TS_INDEX_TYPE_PRECISE)
      {
     	 strIndexType = "PRECISE";
      }
      else if (_indexType == DK_TS_INDEX_TYPE_GTR)
      {
     	 strIndexType = "GTR";
      }
      cout << "*Index type " << strIndexType << endl;
      _indexADD = pIndxEntOut->getIndexFeature();
      if (_indexADD == DK_TS_INDEX_FEATURE_CASE_ENABLED)
      {
     	 strIndexADD = "CASE_ENABLED";
      }
      if (_indexADD != 0)
      {
	cout << "*Index feature " << strIndexADD << endl;
      }
      cout << "*Index ccsid " << pIndxEntOut->getIndexCCSID() << endl;
      cout << "*Index libid " << pIndxEntOut->getLibraryId() << endl;
      cout << "*Index LSCE " << pIndxEntOut->getLibraryClientServices() << endl;
      cout << "*Index LSSE " << pIndxEntOut->getLibraryClientServices() << endl;
      cout << "*Index DataArea " << pIndxEntOut->getIndexDataArea() << endl;
      cout << "*Index WorkArea " << pIndxEntOut->getIndexWorkArea() << endl;
      cout << "*Index Title " << pIndxEntOut->getIndexTitle() << endl;
      cout << "*Index Title CCSID " << pIndxEntOut->getIndexTitleCCSID() << endl;
      cout << "*Index Desc " << pIndxEntOut->getIndexDescription() << endl;
      cout << "*Index Desc CCSID " << pIndxEntOut->getIndexDescriptionCCSID() << endl;

      if (pIndxEntOut != 0)
        delete pIndxEntOut;
      dsTS.disconnect();
      cout << "datastore disconnected" << endl;
   }
   catch(DKException &exc)
   {
      cout << "Error id" << exc.errorId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
         cout << "Error text:" << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
         const DKExceptionLocation* p = exc.locationAtIndex(g);
         cout << "Filename: " << p->fileName() << endl;
         cout << "Function: " << p->functionName() << endl;
         cout << "LineNumber: " << p->lineNumber() << endl;
      }

      cout << "Exception Class Name: " << exc.name() << endl;
   }
   
   cout << "done ..." << endl;
   
}

