/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/*
 * Filename       : TSysAdminFed.java
 * Description    : test Sys Admin functions
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKConstant2Fed.h>
#include <DKString.hpp>
#include <DKAny.hpp>
#include <DKDatastoreFed.hpp>
#include <DKDatastoreDefFed.hpp>
#include <DKDatastoreAdminFed.hpp>
#include <DKException.hpp>
#include <DKEnvironment.hpp>
#include <dkAttrDef.hpp>
#include <DKAttrDefFed.hpp>
#include <DKEntityDefFed.hpp>
#include <DKAttrInventoryDefFed.hpp>
#include <DKAttrMappingFed.hpp>
#include <DKAttrMapDef.hpp>
//#include <dkResultSetCursor.hpp>
#include <DKEntityInventoryDefFed.hpp>
#include <DKServerInventoryMgmtFed.hpp>
#include <DKUserMgmtFed.hpp>
#include <DKServerMgmtImpFed.hpp>
#include <DKServerTypeMgmtImpFed.hpp>
#include <DKServerTypeDefFed.hpp>
#include <DKErrorLogMgmtFed.hpp>
#include <DKServerMapDefFed.hpp>
#include <DKUserMgmtFed.hpp>
#include <DKUserDataFed.hpp>
#include <DKUserGroupDataFed.hpp>
#include <DKUserMapDataFed.hpp>
#include "DKSequentialCollection.hpp"
#include "DKConstant.h"
#include "DKConstant2Fed.h"
#include "DKMessageId.h"
#include "DKMessageIdFed.h"

#define new DEBUG_NEW



void main(int argc, char *argv[])
{
   cout << "begin..." << endl;
   // Indicate this is a Console Application on Windows NT/95 for error
   // message code page conversion to OEM code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_SS_WINDOWS is the default.
   DKEnvironment::setSubSystem(DK_SS_CONSOLE);

   //--------------------------------------------------------------// 
   // Checking for input parameters                                //
   //--------------------------------------------------------------//   
   if (argc < 4)  {
      cout <<"Usage syntax: "<<endl;
      cout <<"\t TExecQryStrExprFed <feddb> <userid> <pw> " << endl;
      return;
   }
   // ### get input parameters
   DKString libsrv(argv[1]);
   DKString userid(argv[2]);
   DKString pw    (argv[3]);
   DKDatastoreFed dsFed; // must be outside try block to avoid exception trap error.

   try{

      // All set; Connect and execute the compound query expression
/* ****************************************************************************
 * 0. Connect to the Fed Datastore
 ******************************************************************************/
       
    cout << " *** connecting to " << libsrv << " *** " << endl;
    dsFed.connect(libsrv, userid, pw);
    cout << " \t -----> connected " << endl;
    cout << "     user " << dsFed.userName() << ", dsName " << dsFed.datastoreName() << endl;
     
    int i, j, k;
    dkCollection* pCol = 0;
    dkIterator* iter = 0;
    long size;  
/* ****************************************************************************
 * 1. DKServerInventoryMgmtFed, DKAttrInventoryDefFed, DKEntityInventoryDefFed
 ******************************************************************************/
/*       
    long srvSize, entitySize, attrSize;
    DKString* srvNames = 0;
    DKString* entityNames = 0;
    DKString* attrNames;
    DKAttrInventoryDefFed* at = 0;
    DKAttrInventoryDefFed* at1 = 0;
    DKAttrInventoryDefFed* at2 = 0;
    DKAttrInventoryDefFed* at3 = 0;

    DKTextInventoryDefFed* td = 0;
    DKTextInventoryDefFed* td1 = 0;
    DKString srvName, entityName, attrName, indexName;
    
    DKServerInventoryMgmtFed* srv = new DKServerInventoryMgmtFed(&dsFed, DK_FED_FA_ADMIN);
  
    pCol = srv->listServers();
    iter = pCol->createIterator();
    while (iter->more()){
        DKServerMapDefFed* sm = (DKServerMapDefFed* )(void*) *iter->next();
        cout << "Server Name = " << sm->getName() << endl;
        delete sm;
    }
    delete iter;
    delete pCol;

        
    
    
    srvNames = srv->listServerNames(srvSize);

    for (i = 0; i < srvSize; i++){
        //cout << "server Name [" << i << "] = " << srvNames[i] << endl;
	    pCol = srv->listInventory(srvNames[i]);
        iter = pCol->createIterator();
        while (iter->more()){
            DKAttrInventoryDefFed* at = (DKAttrInventoryDefFed* )(void*) *iter->next();
            //cout << "Attr Name = " << at->getName() << endl;
            delete at;
        }
        delete iter;
        delete pCol;


        pCol = srv->listServerEntities(srvNames[i]);
        iter = pCol->createIterator();
        while (iter->more()){
            DKEntityInventoryDefFed* ed = (DKEntityInventoryDefFed* )(void*) *iter->next();
            //cout << "Entity Name = " << ed->getName() << endl;
            delete ed;
        }
        delete iter;
        delete pCol;

        

        entityNames = srv->listServerEntityNames(srvNames[i], entitySize);
        for (j = 0; j < entitySize; j++){
            //cout << "entity Name [" << j << "] = " << entityNames[j] << endl;
	        pCol = srv->listServerEntityAttrs(srvNames[i], entityNames[j]);
            iter = pCol->createIterator();
            while (iter->more()){
               DKAttrInventoryDefFed* at = (DKAttrInventoryDefFed* )(void*) *iter->next();
               //cout << "Inventory Name = " << at->getName() << endl;
               delete at;
            }
            delete iter;
            delete pCol;

            pCol = srv->listInventory(srvNames[i], entityNames[j]);
            iter = pCol->createIterator();
            while (iter->more()){
                DKAttrInventoryDefFed* at = (DKAttrInventoryDefFed* )(void*) *iter->next();
                //cout << "Inventory Name = " << at->getName() << endl;
                delete at;
            }
            delete iter;
            delete pCol;

             
            attrNames = srv->listServerEntityAttrNames(srvNames[i], entityNames[j], attrSize);
            for (k = 0; k < attrSize; k ++){
              	at = srv->getInventory(srvNames[i], entityNames[j], attrNames[k]);
              //cout << "attribute Name [" << k << "] = " << at->getName() << endl;
                delete at;
            } 
            if (attrSize > 0) delete [] attrNames;
        }
        if (entitySize > 0) delete [] entityNames;
    }
    if (srvSize > 0) delete [] srvNames;

	pCol = srv->listInventory();
    iter = pCol->createIterator();
    i = 0;
    while (iter->more()){
        at = (DKAttrInventoryDefFed*)(void*) *iter->next();
        
        attrName = at->getName();
        entityName = at->getEntityName();
        srvName = at->getServerName();

        //cout << "Before removing ... " << endl;
        //cout << "Inventory name = " << attrName << endl;
        //cout << "Inventory entity name = " << entityName << endl;
        //cout << "Inventory server name = " << srvName << endl;
          
        srv->removeInventory(srvName, entityName, attrName);
        at1 = srv->getInventory(srvName, entityName, attrName);

        //cout << "After removing ... " << endl;
        if (at1 == NULL) cout << "Inventory is removed" << endl;
        else cout << "Warning! Inventory has not been removed" << endl;

        //cout << "Adding back ... " << endl;
        srv->addInventory(at);
        at2 = srv->getInventory(srvName, entityName, attrName);
        
        //cout << "After adding back ... " << endl;
        //cout << "Inventory name = " << at2->getName() << endl;
        //cout << "Inventory entity name = " << at2->getEntityName() << endl;
        //cout << "Inventory server name = " << at2->getServerName() << endl;
        delete at2;
        //cout << "Before updating ..." << endl;
        //cout << "Inventory max = " << at->getMax() << endl;
        //cout << "Inventory name = " << attrName << endl;
        //cout << "Inventory entity name = " << entityName << endl;
        //cout << "Inventory server name = " << srvName << endl;
        
        at->setMax(100);
        srv->updateInventory(at); 
        delete at;
        //cout << "After updating ..." << endl; 
        at = srv->getInventory(srvName, entityName, attrName);
        //cout << "Inventory max = " << at->getMax() << endl;
        //cout << "Inventory name = " << at->getName() << endl;
        //cout << "Inventory entity name = " << at->getEntityName() << endl;
        //cout << "Inventory server name = " << at->getServerName() << endl;
        delete at;
        i++;
    } // end while
    delete pCol;   
    delete iter;

   
	pCol = srv->listTextInventory();

    iter = pCol->createIterator();
    i = 0;
    while (iter->more()){
        td = (DKTextInventoryDefFed*)(void*) *iter->next();
       
        indexName = td->getIndexName();
        srvName = td->getServerName();

        cout << "Before removing ... " << endl;
        cout << "Inventory index name = " << indexName << endl;
        cout << "Inventory server name = " << srvName << endl;

        srv->removeTextInventory(srvName, indexName);
        td1 = srv->getTextInventory(srvName, indexName);

        cout << "After removing ... " << endl;
        if (td1 == NULL) cout << "Inventory is removed" << endl;
        else cout << "Warning! Inventory has not been removed" << endl;

        cout << "Adding back ... " << endl;
        srv->addTextInventory(td);
        delete td; 
        td1 = srv->getTextInventory(srvName, indexName);

        cout << "After adding back ... " << endl;
        cout << "Inventory index name = " << td1->getIndexName() << endl;
        cout << "Inventory server name = " << td1->getServerName() << endl;
        
        cout << "Before updating ..." << endl;
        cout << "Inventory status = " << td1->getStatus() << endl;
        cout << "Inventory index name = " << indexName << endl;
        cout << "Inventory server name = " << srvName << endl;
        
        td1->setStatus(100);
        srv->updateTextInventory(td1); 
        delete td1;
        cout << "After updating ..." << endl; 
        td1 = srv->getTextInventory(srvName, indexName);
        cout << "Inventory status = " << td1->getStatus() << endl;
        cout << "Inventory entity name = " << td1->getIndexName() << endl;
        cout << "Inventory server name = " << td1->getServerName() << endl;
        delete td1;
        i++;
    } // end while
   
    delete pCol;
    delete iter;



        for (j = 0; j < entitySize; j++) {
	        srv->removeInventory(srvNames[i], entityNames[j]);

        }
    
	    DKBoolean b1 = srv->checkServerInventory() ;
	
        for (i = 0; i < srvSize; i++){
       	   DKBoolean b2 = srv->checkServerInventory(srvNames[i]) ;

           pCol = srv->listTextInventory(srvNames[i]);
           iter = pCol5->createIterator();
           while(iter->more()){
               td = (DKTextInventoryDefFed*)(void*) *iter->next();
               cout << td->getIndexName() << endl;
               cout << td->getServerName() << endl;
               delete td;
           }
           delete pCol;
           delete iter;
        }

	
    //srv->removeAllTextInventory();
    //srv->removeAllInventory();

       delete srv;
*/

/************************************************************************
 * 2. DKUserMgmtFed
 ************************************************************************/
/*    DKUserMgmtFed* user = new DKUserMgmtFed(&dsFed);
    DKUserGroupDataFed* grp = 0;
    DKString* grpNames = 0;
    DKString* grpUsers = 0;
    char** arUser = 0;   
    DKUserMapDataFed* mapUser = 0;
    DKUserDataFed* sd = 0;
        
    // user

    DKString userId2 = "FayWang5";
    DKString userId3 = "FayWang6";
    DKString password = "password";
    //user->addUser(userId2, password);        // add FayWang5
    //user->addUser(userId3, password);        // add FayWang6
    sd = new DKUserDataFed();
    sd->setUserName("FayWang4");              // add FayWang4
    sd->setUserPWD("password");
    //user->addUser(*sd);
    delete sd;
    //sd = user->getUser("FayWang6");          
    //cout << "UserName = " << sd->getUserName() << endl;
    //delete sd;
    //user->delUser("FayWang4");                // del FayWang4 
    sd = new DKUserDataFed();
    sd->setUserName("FayWang6");
    sd->setLotusID("Lotus1");
    user->updateUser(*sd);
    delete sd;
    sd = user->getUser("FayWang6");
    cout << "New password = " << sd->getLotusID() << endl;
    delete sd;
    
    DKString* userNames = user->listUsers(size);
    for (i = 0; i < size; i++)
        cout << "user list = " << userNames[i] << endl;
    delete [] userNames; 
    
    // group
    user->addUserGroup("Group5");
    grp = new DKUserGroupDataFed("Group6");
    user->addUserGroup(*grp);
    delete grp;
    grpNames = user->listUserGroups(size);
    for (i = 0; i < size; i++)
        cout << "Before: grp list = " << grpNames[i] << endl;
    delete [] grpNames; 

    user->delUserGroup("Group5");
    user->removeUserGroup("Group6");

    user->addUserGroup("Group4");
    
    grpNames = user->listUserGroups(size);
    for (i = 0; i < size; i++)
        cout << "After: grp list = " << grpNames[i] << endl;
    delete [] grpNames; 

    grp = user->getUserGroup("Group4");
    grp->setDescription("This is a test group");
    grp->setNewUserGroupName("Group4-1");
    user->updateUserGroup(*grp);
    delete grp;
    grp = user->getUserGroup("Group4-1");
    cout << "New description = " << grp->getDescription() << endl;
    delete grp;

    // add user to group
    user->addToGroup("Group4", "FayWang6");
    user->addToGroup("Group4", "FayWang5");
    grpUsers = user->listGroupUsers("Group4", size);
    for (i = 0; i < size; i++)
        cout << "Before removing FayWang5, 6: grp user list = " << grpUsers[i] << endl;
    delete [] grpUsers; 
    user->removeFromGroup("Group4", "FayWang5");
    user->removeFromGroup("Group4", "FayWang6");
    grpUsers = user->listGroupUsers("Group4", size);
    for (i = 0; i < size; i++)
        cout << "After removing FayWang5, 6: grp user list = " << grpUsers[i] << endl;
    if (size > 0) delete [] grpUsers; 
    
    arUser = new char* [2];
    arUser[0] = (char *) "cmbadmin";
    arUser[1] = (char *) "edms1";
    user->addUsersToGroup("Group4", (const char**) arUser, 2);
    grpUsers = user->listGroupUsers("Group4", size);
    for (i = 0; i < size; i++)
        cout << "After adding edms1 and cmbadmin: grp user list = " << grpUsers[i] << endl;
    delete [] grpUsers; 

    user->removeUsersFromGroup("Group4", (const char**) arUser, 2);
    grpUsers = user->listGroupUsers("Group6", size);
    for (i = 0; i < size; i++)
        cout << "After removing edms1 and cmbadmin: grp user list = " << grpUsers[i] << endl;
    if (size > 0 ) delete [] grpUsers; 
   
    delete [] arUser;

    user->checkUser("FayWang6", "password3"); 
    cout << "cmbadmin access level = " << user->getAccessLevel("cmbadmin") << endl;
    user->changePassword("FayWang6", "password", "password3");
    user->changePassword("FayWang5", "password2");
    sd = user->getUser("FayWang5");
    cout << "FayWang5's new password = " << sd->getUserPWD() << endl;
    delete sd;

    sd = user->getUser("FayWang6");
    cout << "FayWang6's new password = " << sd->getUserPWD() << endl;
    delete sd;

    mapUser = new DKUserMapDataFed();
    mapUser->setFedUserName("FayWang5");
    mapUser->setMapPassword("password");
    mapUser->setMapUserName("edms1");
    mapUser->setMapServerName("LSMUFASA");
    mapUser->setMapServerType("DL");
    user->addMapUser(*mapUser);

    mapUser->setMapPassword("password");
    user->updateMapUser(*mapUser);

    mapUser->setFedUserName("FayWang2");
    mapUser->setMapPassword("password");
    mapUser->setMapUserName("edms1");
    mapUser->setMapServerName("LSMUFASA");
    mapUser->setMapServerType("DL");
    user->addMapUser(*mapUser);

    delete mapUser;
    
    user->removeMapUser("FayWang5", "LSMUFASA");
    user->removeMapUser("FayWang2", "LSMUFASA");

    pCol = user->listMapUsers();
    iter = pCol->createIterator();
    i = 0;
    while (iter->more()){
        mapUser = (DKUserMapDataFed*) (void*) *iter->next();
        //cout << "mapUser[" << i << "].FedUserName = " << mapUser->getFedUserName() << endl; 
        cout << "mapUser[" << i << "].MapUserName = " << mapUser->getMapUserName() << endl; 
        cout << "mapUser[" << i << "].MapServerName = " << mapUser->getMapServerName() << endl; 
        i++;
        delete mapUser;
    }
    delete pCol;
    delete iter;


    pCol = user->listMapUsers("cmbadmin");
    iter = pCol->createIterator();
    i = 0;
    while (iter->more()){
        mapUser = (DKUserMapDataFed*) (void*) *iter->next();
        //cout << "mapUser[" << i << "].FedUserName = " << mapUser->getFedUserName() << endl; 
        cout << "mapUser[" << i << "].MapUserName = " << mapUser->getMapUserName() << endl; 
        cout << "mapUser[" << i << "].MapServerName = " << mapUser->getMapServerName() << endl; 
        i++;
        delete mapUser;
    }
    delete pCol;
    delete iter;

    user->setUserMappingEnable(true);
    if (user->isUserMappingEnable()) cout << "YES" << endl;
    else cout << "NO" << endl;

    delete user;

*/    

/************************************************************************
 * 3. DKServerMgmtFed, DKServerMapDefFed
 ************************************************************************/
/*
    DKServerMgmtImpFed* srvMgmt = new DKServerMgmtImpFed(&dsFed);
    DKServerMapDefFed* srvMap = 0;
    DKString* srvNamesM = 0;
    long srvMgmtSize;

    //listServers
    pCol = srvMgmt->listServers();
    iter = pCol->createIterator();
    i = 0;
    while (iter->more()){
        srvMap = (DKServerMapDefFed*) (void*) *iter->next();
        cout << "srvMap[" << i << "] = " << srvMap->getName() << endl; 
        i++;
        delete srvMap;
    }
    delete pCol;
    delete iter;

    srvNamesM = srvMgmt->list(srvMgmtSize);
    for (i = 0; i < srvMgmtSize; i++)
        cout << "srvNamesM[" << i << "] = " << srvNamesM[i] << endl;
    if (srvMgmtSize > 0) delete [] srvNamesM;

	srvMap = srvMgmt->get ("LSMUFASA");

    // Before removing
    cout << "Before removing ..." << endl;
    srvNamesM = srvMgmt->listByType("DL", srvMgmtSize);
    for (i = 0; i < srvMgmtSize; i++)
        cout << "  srvNamesM[" << i << "] = " << srvNamesM[i] << endl;
    if (srvMgmtSize >0) delete [] srvNamesM;

    // After removing
    cout << "After removing ..." << endl; 
    srvMgmt->remove("LSMUFASA");
    srvNamesM = srvMgmt->listByType("DL", srvMgmtSize);
    for (i = 0; i < srvMgmtSize; i++)
        cout << "  srvNamesM[" << i << "] = " << srvNamesM[i] << endl;
    if (srvMgmtSize >0) delete [] srvNamesM;

    // Adding back
    srvMgmt->add(*srvMap);
    delete srvMap;
    srvNamesM = srvMgmt->listByType("DL", srvMgmtSize);
    cout << "After adding back ..." << endl;
    for (i = 0; i < srvMgmtSize; i++)
        cout << "  srvNamesM[" << i << "] = " << srvNamesM[i] << endl;
    if (srvMgmtSize >0) delete [] srvNamesM;

    // list by "TS"
    srvNamesM = srvMgmt->listByType("TS", srvMgmtSize);
    for (i = 0; i < srvMgmtSize; i++)
        cout << "srvNamesM[" << i << "] = " << srvNamesM[i] << endl;
    if (srvMgmtSize >0) delete [] srvNamesM;

    // list by "DES"
    srvNamesM = srvMgmt->listByType("DES", srvMgmtSize);
    for (i = 0; i < srvMgmtSize; i++)
        cout << "srvNamesM[" << i << "] = " << srvNamesM[i] << endl;
    if (srvMgmtSize >0) delete [] srvNamesM;


    //update
	srvMap = srvMgmt->get ("TMMUF");
    cout << "Old description = " << srvMap->getDescription() << endl;
    srvMap->setDescription("This is a test for DKServerDefFed");
	srvMgmt->update (*srvMap);
    delete srvMap;
	srvMap = srvMgmt->get ("TMMUF");
    cout << "New description = " << srvMap->getDescription() << endl;
    delete srvMap;

    //list associate servers
    pCol = srvMgmt->listAssocSearchServers("LSSNPUX");
    iter = pCol->createIterator();
    i = 0;
    while (iter->more()){
        srvMap = (DKServerMapDefFed*) (void*) *iter->next();
        cout << "srvMap[" << i << "] = " << srvMap->getName() << endl; 
        i++;
        delete srvMap;
    }
    delete pCol;
    delete iter;

    //list associate backend server names
    srvNamesM = srvMgmt->listAssocBackendServerNames("TMSNP", srvMgmtSize);
    for (i = 0; i < srvMgmtSize; i++)
        cout << "  srvNamesM[" << i << "] = " << srvNamesM[i] << endl;
    if (srvMgmtSize > 0) delete [] srvNamesM;

    //list all associate search server names
    srvNamesM = srvMgmt->listAllAssocSearchServerNames(srvMgmtSize);
    for (i = 0; i < srvMgmtSize; i++)
        cout << "  srvNamesM[" << i << "] = " << srvNamesM[i] << endl;
    if (srvMgmtSize >0) delete [] srvNamesM;

    // removing and adding associate search servers
    cout << "Removing associate search servers ... " << endl;
	srvMgmt->disassocSearchServer ("LSMUFASA", "TMMUF");
    srvMgmt->assocSearchServer ("LSMUFASA", "TMMUF");
    srvNamesM = srvMgmt->listAssocBackendServerNames("TMMUF", srvMgmtSize);
    for (i = 0; i < srvMgmtSize; i++)
        cout << "  srvNamesM[" << i << "] = " << srvNamesM[i] << endl;
    if (srvMgmtSize >0) delete [] srvNamesM;

    delete srvMgmt;
*/
/************************************************************************
 * 4. DKServerTypeMgmtFed, DKServerTypeDefFed
 ************************************************************************/
/*    DKServerTypeMgmtImpFed* srvTypeMgmt = new DKServerTypeMgmtImpFed(&dsFed);
    DKString* srvTypeNames = 0;
    long srvTypeSize;
    DKServerTypeDefFed* srvType = 0;
    
    //list before removing
    cout << "Before removing ... "<< endl;
    srvTypeNames = srvTypeMgmt->list(srvTypeSize);
    for (i = 0; i < srvTypeSize; i++)
        cout << "  srvTypeNames[" << i << "] = " << srvTypeNames[i] << endl;
    if (srvTypeSize >0) delete [] srvTypeNames;

    // get and update before removing, so that we can add it back later
    srvType = srvTypeMgmt->get ("OD");
    srvType->setDescription("This a new test for DKServerTypeDef");
    srvTypeMgmt->update(*srvType);
    delete srvType;
    srvType = srvTypeMgmt->get("OD");
    cout << "After updating, srvType description = " << srvType->getDescription() << endl;

    // list after removing
    cout << "After removing ..." << endl;
    srvTypeMgmt->remove ("OD");
    srvTypeNames = srvTypeMgmt->list(srvTypeSize);
    for (i = 0; i < srvTypeSize; i++)
        cout << "  srvTypeNames[" << i << "] = " << srvTypeNames[i] << endl;
    if (srvTypeSize >0) delete [] srvTypeNames;

    // list after adding it back
    srvTypeMgmt->add(*srvType);
    delete srvType;
    srvTypeNames = srvTypeMgmt->list(srvTypeSize);
    for (i = 0; i < srvTypeSize; i++)
        cout << "  srvTypeNames[" << i << "] = " << srvTypeNames[i] << endl;
    if (srvTypeSize >0) delete [] srvTypeNames;
 
    //listServerTypes
    pCol = srvTypeMgmt->listServerTypes();
    iter = pCol->createIterator();
    i = 0;
    while (iter->more()){
        srvType = (DKServerTypeDefFed*) (void*) *iter->next();
        cout << "srvType[" << i << "] = " << srvType->getCppClass() << endl; 
        i++;
        delete srvType;
    }
    delete pCol;
    delete iter;
    delete srvTypeMgmt;
*/
/************************************************************************
 * 5. DKErrorLogMgmtFed, DKLogDefFed
 ************************************************************************/
    DKErrorLogMgmtFed* errMgmt = new DKErrorLogMgmtFed(&dsFed, DK_FED_FA_ADMIN);
    DKLogDefFed* log1 = 0;
    DKLogDefFed* log2 = 0;
    DKLogDefFed* log = 0;
    DKTimestamp* ts = 0;

    // before creating an error log
    cout << "Before creating an error log ... "<< endl;
    pCol = errMgmt->listLogs();
    iter = pCol->createIterator();
    i = 0;
    while (iter->more()){
        log1 = (DKLogDefFed*) (void*) *iter->next();
        cout << "log[" << i << "] = " << log1->getLogEntry() << endl; 
        i++;
        delete log1;
    }
    delete pCol;
    delete iter;

    // create an error log
    log1 = new DKLogDefFed(&dsFed);
    log1->setLogEntry("This is an error log test1");
    ts = new DKTimestamp();
    log1->setLogTime(ts);
    errMgmt->addLog(log1);
    delete ts;
    //delete log1; 
    log2 = new DKLogDefFed(&dsFed);
    log2->setLogEntry("This is an error log test2");
    ts = new DKTimestamp();
    log2->setLogTime(ts);
    log2->add();
    delete ts; 
    //delete log2;
    
    // After creating error logs

    // *********************************

    cout << "After creating an error log ... "<< endl;
    pCol = errMgmt->listLogs();
    iter = pCol->createIterator();
    i = 0;
    while (iter->more()){
        log = (DKLogDefFed*) (void*) *iter->next();
        cout << "log[" << i << "] = " << log->getLogEntry() << endl; 
        i++;
        log->setDatastore(&dsFed);
		DKTimestamp* ts = log->getLogTime();	
		cout << "log[" << i << "] = " << ts->getYear() << "-" << ts->getMonth() << "-" << ts->getDay() << endl;
        log->del();
        log->add();
        delete log;
    }
    delete pCol;
    delete iter;

    
    errMgmt->removeLog(*(log1->getLogTime()));
    errMgmt->addLog(log1);
    errMgmt->removeLogBefore(*(log2->getLogTime()));
    delete log1;
    delete log2;

    pCol = errMgmt->listLogs();
    iter = pCol->createIterator();
    i = 0;
    while (iter->more()){
        log = (DKLogDefFed*) (void*) *iter->next();
        cout << "log[" << i << "] = " << log->getLogEntry() << endl; 
        i++;
        log->del();
        log->add();
        delete log;
    }

    if (pCol->cardinality() == 0) cout << "No Log!!" << endl;
    delete pCol;
    delete iter;
    delete errMgmt;

/************************************************************************
 * 6. DKDatastoreAdminFed
 ************************************************************************/
/*
    DKDatastoreDefFed* dsDef = (DKDatastoreDefFed*)dsFed.datastoreDef();
    DKDatastoreAdminFed* dsAdmin = (DKDatastoreAdminFed*)dsDef->datastoreAdmin();
    pCol = dsAdmin->listServers();
    iter = pCol->createIterator();
    i = 0;
    while (iter->more()){
        DKServerMapDefFed* srvMap = (DKServerMapDefFed*) (void*) *iter->next();
        cout << "srvMap[" << i << "] = " << srvMap->getName() << endl; 
        i++;
        delete srvMap;
    }
    delete pCol;
    delete iter;
*/
/************************************************************************
 * 100. Disconnect from datastore
 ************************************************************************/
    // disconnects
    cout << "\n\n *** disconnect from the datastore Fed. ***" << endl;
    dsFed.disconnect();
    cout << " *** datastore Fed disconnected ***" << endl;
     
   }
   catch(DKException &exc)
   {
       cout << "Error id " << exc.errorId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
         cout << "Error text: " << exc.text(i) << endl;
     
      for (unsigned long g=0; g< exc.locationCount();g++) {
         const DKExceptionLocation* p = exc.locationAtIndex(g);
         cout << "Filename: " << p->fileName() << endl;
         cout << "Function: " << p->functionName() << endl;
         cout << "LineNumber: " << p->lineNumber() << endl;
      }
     
      cout << "Exception Class Name: " << exc.name() << endl;
   }
   
   cout << "done ..." << endl;   
}


