/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

//*****************************************************************************
// File Name   = DemoSchema.java
// Description = Demonstrate CMBSchemaManagement bean functionality
// Author      = afic
// Date        = 03/29/1999
//
//*****************************************************************************

import com.ibm.mm.beans.*;

import java.beans.*;

public class DemoSchema {
    UtilPersistent per = new UtilPersistent();
    UtilSimpleUI ui = new UtilSimpleUI();
    CMBSchemaManagement schemaBean = null;

    DemoSchema() {
        try {
            System.out.println("Creating CMBSchemaManagement bean using " + "ser/class/jar specified in the classpath.");
            schemaBean = (com.ibm.mm.beans.CMBSchemaManagement) Beans.instantiate(null, "com.ibm.mm.beans.CMBSchemaManagement");
        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    void changeProperty() {
        if (ui.getBoolean("Enable the schema cache capability?"))
            schemaBean.setCacheEnabled(true);
        else
            schemaBean.setCacheEnabled(false);

        if (ui.getBoolean("Enable the schema trace capability?"))
            schemaBean.setTraceEnabled(true);
        else
            schemaBean.setTraceEnabled(false);
    }

    void run() {
        int count;
        try {
            // get server names
            System.out.println("Getting server names...");
            String svNames[] = schemaBean.getServerNames();
            count = svNames.length;
            System.out.println("Done, server count is: " + count);
            for (int i = 0; i < count; ++i)
                System.out.println("Server[" + i + "] = " + svNames[i]);
            System.out.println("");

            // get search template names
            System.out.println("Getting search template names...");
            String stNames[] = schemaBean.getSearchTemplateNames();
            count = stNames.length;
            System.out.println("Done, search template count is: " + count);
            for (int i = 0; i < count; ++i)
                System.out.println("Template[" + i + "] = " + stNames[i]);
            System.out.println("");

            // get entity names
            System.out.println("Getting entity names...");
            String entNames[] = schemaBean.getEntityNames();
            count = entNames.length;
            System.out.println("Done, entity count is: " + count);
            String attrNames[] = null;
            int attrCount = 0;
            for (int i = 0; i < count; ++i) {
                // for each entity, get attribute names
                System.out.println("Entity[" + i + "] = " + entNames[i]);
                attrNames = schemaBean.getEntityAttrNames(entNames[i]);
                attrCount = attrNames.length;
                System.out.println("Entity[" + i + "] = " + entNames[i] + ", has " + attrCount + " attributes");
                for (int j = 0; j < attrCount; ++j) {
                    System.out.println("  Attribute[" + j + "] = " + attrNames[j]);
                }
            }
            System.out.println("");

        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    void load() {
        schemaBean = (CMBSchemaManagement) per.load();
    }

    void save() {
        per.save(schemaBean);
    }

    public static void main(String argv[]) {
        String demoName = "IBM Enterprise Information Portal Sample Application: DemoSchema";
        String copyright = "(c ) Copyright IBM Corp. 1998,1999. All Rights Reserved.";

        System.out.println("");
        System.out.println(demoName);
        System.out.println(copyright);
        System.out.println("");
        System.out.println("");

        UtilSimpleUI ui = new UtilSimpleUI();
        DemoConnect connDemo = new DemoConnect();
        DemoSchema demo = new DemoSchema();
        boolean loopControl = true;

        demo.schemaBean.setConnection(connDemo.connBean);
        System.out.println("Going to connect to the server...");
        connDemo.connect();

        while (loopControl) {
            System.out.println("");
            System.out.println("Selections:");
            System.out.println("0. Exit");
            System.out.println("1. Re-load the CMBSchemaManagement bean from a file");
            System.out.println("2. Change property values");
            System.out.println("3. Run the bean");
            System.out.println("4. Save this CMBSchemaManagement bean to a file");
            switch (ui.getInteger("Enter your selection:")) {
                case 0 :
                    loopControl = false;
                    break;
                case 1 :
                    demo.load();
                    break;
                case 2 :
                    demo.changeProperty();
                    break;
                case 3 :
                    demo.run();
                    break;
                case 4 :
                    demo.save();
                    break;
            }
        }

        connDemo.disconnect();
        System.out.println("Bye.");
    }
}