/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/*
 * Filename       : TListDocModelsTS.java
 * Description    : List document models for a text search server
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

// TListDocModelsTS class
public class TListDocModelsTS implements DKConstantDL {

  // Main method
  public static void main(String argv[]){
    
      // Indicate this is a Console Application on Windows NT/95 for error
      // message display in dos console code page. If this was a Windows
      // GUI (Graphic User Interface) Application this would not be necessary
      // because DK_CM_SS_WINDOWS is the default.
      DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
      if (argv.length < 1){
          System.out.println("Invoke Syntax: " );
          System.out.println("  java TListDocModelsTS <srchSrv> " );
          return;
      }
      
      String srchSrv = argv[0];
       
      DKDatastoreTS dsTS = null;
      try {
         DKSequentialCollection pCol = null;
         DKDatastoreDefTS dsDef = null;
         DKDatastoreAdminTS dsAdmin = null;
         dkIterator pIter = null;
         DKDocModelTS pDocModel = null;
         int ccsid = 0;
         String strDocModelName = null;
         int i = 0;
         Integer iOpt = null;
         dsTS = new DKDatastoreTS();
         
         System.out.println("connecting to datastore"); 
         dsTS.connect(srchSrv,"",' ');
         System.out.println("datastore connected"); 
         
         System.out.println("list doc models");
         dsDef = (DKDatastoreDefTS)dsTS.datastoreDef();
         dsAdmin = (DKDatastoreAdminTS)dsDef.datastoreAdmin();
         pCol = (DKSequentialCollection) dsAdmin.listDocModels("");
         pIter = pCol.createIterator();
         i = 0;
         while (pIter.more()){
             i++;
             pDocModel = (DKDocModelTS)pIter.next();
             strDocModelName = pDocModel.getName();
             ccsid = pDocModel.getCCSID();
             System.out.println("Doc model [" + i + "] - " + strDocModelName + " CCSID - " + ccsid);
         }
         System.out.println(i + " doc models listed");
    
         dsTS.disconnect();
         System.out.println("datastore disconnected"); 
         dsTS.destroy();
      }
      catch (DKException exc){
     	 try {
     	     dsTS.destroy();
     	 }
     	 catch (Exception e)
     	 {
     	  e.printStackTrace();
     	 }         
         System.out.println("Exception name " + exc.name());
         System.out.println("Exception message " + exc.getMessage());
         exc.printStackTrace();
      }
      catch (Exception exc){
     	 try {
     	     dsTS.destroy();
     	 }
     	 catch (Exception e)
     	 {
     	  e.printStackTrace();
     	 }         
         System.out.println("Exception message " + exc.getMessage());
         exc.printStackTrace();
      }
  }
}

