/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
//*****************************************************************************
// txdoAddVSDL.java - Test DKBlobDL for add() of media object
// (this test case requires you to know the existing itemId in the library.)
// invoke: java txdoAddVSDL <fileName> <partId> <itemId>
//   or
// invoke: java txdoAddVSDL <fileName> <partId> -- with default itemId
// note:
//  you can also code the itemId, partId and fileName in this program and 
//  invoke as:  java txdoAddVSDL
//*****************************************************************************
import com.ibm.mm.sdk.server.*;
import com.ibm.mm.sdk.common.*;
import java.io.*;
import java.lang.*;

public class txdoAddVSDL 
   implements DKConstantDL
{
  //replace following with your library server name, userid, pasword
  public static final String STR_LIB_SERVER  = "LIBSRVRN";
  public static final String STR_USER_ID     = "FRNADMIN";
  public static final String STR_PASSWORD    = "PASSWORD";

  // Main method
  public static void main(String[] args)
  {
   
    String  fileName = "/icing1.mpg1";        //an media object
    String itemId = "K5#NLPETZ#TU2D$2";       //an known itemId
    int partId = 45; 
 
    if (args.length == 3)
    {
      fileName = args[0];
      partId = (int)Integer.parseInt(args[1], 10);
      itemId = args[2];
      System.out.println("You enter: java txdoAddVSDL " +
      fileName + " " + partId + " " + itemId);
    }
    if (args.length == 2)
    {
      fileName = args[0];
      partId =(int)Integer.parseInt(args[1], 10);
      System.out.println("You enter: java txdoAddVSDL " +
      fileName + " " + partId );
      System.out.println("The supplied default itemId = " + itemId);
    }
    if (args.length == 1)
    {
      fileName = args[0];
      System.out.println("You enter: java txdoAddVSDL " + fileName);
      System.out.println("The supplied default partId = " + partId);
      System.out.println("The supplied default itemId = " + itemId);
    }
    if (args.length == 0)
    {
      System.out.println("invoke: java txdoAddVSDL <fileName> <partId> <itemId>");
      System.out.println("No parameter, following defaults will be provided:");
      System.out.println("     default fileName = " + fileName);
      System.out.println("     default partId = " + partId);
      System.out.println("     default itemId = " + itemId);
    }
    DKDatastoreDL dsDL = null;
    try 
    {
      // *** connect to datastore
      dsDL = new DKDatastoreDL();
      System.out.println("connecting to datastore..."); 
      dsDL.connect("LIBSRVRP","FRNADMIN","PASSWORD","");
      dsDL.connect(STR_LIB_SERVER, STR_USER_ID, STR_PASSWORD, "");
      System.out.println("datastore connected");

      // *** create xdo and pid
      DKBlobDL axdo = new DKBlobDL(dsDL);
      DKPidXDODL  apid = new DKPidXDODL();
      apid.setPartId(partId);
      apid.setPrimaryId(itemId);
      axdo.setPidObject(apid);
      // *** you must use the content class DK_CC_IBMVSS for a media object
      axdo.setContentClass(DK_DL_CC_IBMVSS);
      System.out.println("contentClass=" + axdo.getContentClass());
      System.out.println("partId = " + axdo.getPartId());

      // *** setup DKMediaStreamInfoDL
      DKMediaStreamInfoDL aVS = new DKMediaStreamInfoDL();
      aVS.setMediaFullFileName(fileName);
      //if fileName contain a list of media segments then use following
      //aVS.setMediaObjectOption(DK_DL_VS_LIST_OF_OBJECT_SEGMENTS);
      aVS.setMediaObjectOption(DK_DL_VS_SINGLE_OBJECT);
      aVS.setMediaHostName("vcharger1.stl.ibm.com");
      aVS.setMediaUserId("root");
      aVS.setMediaPassword("video2");

      //following are optional, if not set default value will be provided
      aVS.setMediaNumberOfUsers(2);
      aVS.setMediaAssetGroup("AG");  //must same as Video Charger defined
      aVS.setMediaType("MPEG1");     
      aVS.setMediaResolution("SIF");
      aVS.setMediaStandard("NTSC");
      aVS.setMediaFormat("SYSTEM");
      axdo.setExtension("DKMediaStreamInfoDL", (dkExtension)aVS);
    
      System.out.println("about to call add()");
      axdo.add();
      System.out.println("add successfully.....");

      System.out.println("after added check for status:");
      boolean flag2 = axdo.isCategoryOf(DK_DL_MEDIA_OBJECT);
      if (flag2)
      {
       DKMediaStreamInfoDL media = (DKMediaStreamInfoDL)axdo.getExtension("DKMediaStreamInfoDL");
       System.out.println(" mediaformat=" + media.getMediaFormat());
       System.out.println(" mediaBitRate=" + media.getMediaBitRate());
       System.out.println(" mediastate(dynamic)=" + axdo.retrieveObjectState(DK_MEDIA_OBJECT));    
      }
      dsDL.disconnect();
      System.out.println("datastore disconnected"); 
      dsDL.destroy();
    }
    catch (DKException exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception name " );
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
  }
}

