/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

// sample connect/disconnect to JDBC

/*
 * Filename       : TClientConnectJDBC.java
 * Description    : test DKDatastoreJDBC for connect and disconnect
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.client.*;
import java.io.*;

// TClientConnectJDBC class
public class TClientConnectJDBC implements DKConstantJDBC {

  // Main method
  public static void main(String argv[]){

      //*** for input parameters
      String url = new String(""),   // url
             userid = new String(""),     //userid
         pw = new String(""); // pw

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //--------------------------------------------------------------
      // Checking for input parameters
      //--------------------------------------------------------------

      if (argv.length < 3)
      {
       System.out.println("Usage: " );
       System.out.println("  java TClientConnectJDBC " +
        "<url> <userid> <pw>" );
       return;
      }
      else
      {
       url = argv[0];
       userid = argv[1];
       pw = argv[2];
      }

    DKDatastoreJDBC dsJDBC = null;
    try {
     String configuration = "JDBCDRIVER=(COM.ibm.db2.jdbc.app.DB2Driver)";
      //  String configuration = "JDBCDRIVER=(sun.jdbc.odbc.JdbcOdbcDriver)";
    dsJDBC = new DKDatastoreJDBC(configuration);
    String userName = dsJDBC.userName();
    String dsName = dsJDBC.datastoreName();
    System.out.println("user " + userName + " dsName " + dsName);
    System.out.println("connecting to datastore");
    dsJDBC.connect(url, userid, pw, "");
    System.out.println("datastore connected");
    userName = dsJDBC.userName();
    dsName = dsJDBC.datastoreName();
    System.out.println("user " + userName + " dsName " + dsName);
    dsJDBC.disconnect();
    System.out.println("datastore disconnected");
    userName = dsJDBC.userName();
    dsName = dsJDBC.datastoreName();
    System.out.println("user " + userName + " dsName " + dsName);
    dsJDBC.destroy();
    }
    catch (DKException exc)
    {
     try {
     dsJDBC.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
     dsJDBC.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

  }
}

