/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

// sample connect/execute/disconnect to JDBC

/*
 * Filename       : TExecuteJDBC.java
 * Description    : Connect to JDBC Datastore.
 *                  Create query string.
 *                  Specify to retrieve folder and documents.
 *                  Specify to retrieve a max result of 5 items.
 *                  Get the result in a resultset cursor.
 *                  Loop thru results.
 *                  Display documents found and their parts and attributes,
 *                   if folders found display them and their documents/
 *                   folders.
 *                  Disconnect from JDBC Datastore.
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;
import java.lang.*;
import java.util.*;

// TExecuteJDBC class
public class TExecuteJDBC implements DKConstantJDBC
{


  // Main method
  public static void main(String argv[])
  {
          
      //*** for input parameters
      String url = new String(""),   //url
             userid = new String(""),     //userid 
  	     pw = new String(""); // pw

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
     
      if (argv.length < 3)
      {
       System.out.println("Usage: " );
       System.out.println("  java TExecuteJDBC " +
        "<url> <userid> <pw>" );
       return;
      }
      else
      {
       url = argv[0];
       userid = argv[1];
       pw = argv[2];
      } 

     String configuration = "JDBCDRIVER=(COM.ibm.db2.jdbc.app.DB2Driver)";
      //  String configuration = "JDBCDRIVER=(sun.jdbc.odbc.JdbcOdbcDriver)";
    DKDatastoreJDBC dsJDBC = null;
    try {
    // Constructing using default constuctor with init method
    dsJDBC = new DKDatastoreJDBC(configuration);
    dkResultSetCursor pCur = null;
    DKNVPair parms[] = new DKNVPair[2];
    String strMax = "5";
    parms[0] = new DKNVPair(DK_CM_PARM_MAX_RESULTS,strMax);
    parms[1] = new DKNVPair(DK_CM_PARM_END,null);
    System.out.println("connecting to datastore"); 
    // url = "jdbc:db2:sample";
      //  url = "jdbc:odbc:sample";
    dsJDBC.connect(url,userid,pw,"");
    String cmd = "";
    cmd = "SELECT * FROM EMPLOYEE";
    System.out.println("datastore connected"); 
    DKDDO p = null;
    DKDDO pDDO = null;
    dkXDO pXDO = null;
    DKPidXDO pidXDO = null;
    int i = 0;
    int numDataItems = 0;
    short k = 0;
    short j = 0;
    String strDataName;
    dkCollection pCol = null;
    dkIterator pIter = null;
    Object a = null;
    dkDataObjectBase pDO = null;
    int cnt = 0;
    System.out.println("query string " + cmd);
    System.out.println("executing query");
    pCur = dsJDBC.execute(cmd,DK_CM_SQL_QL_TYPE,parms);
    System.out.println("datastore executed query");
    System.out.println("cardinality " + pCur.cardinality());
    if (pCur == null)
    {
     System.out.println("cursor null");
    }
    while (pCur.isValid())
    {
     p = pCur.fetchNext();
     if (p != null)
     {
      cnt++;
      i = pCur.getPosition();
      System.out.println("=====> Item " + i + " <=====");
      numDataItems = p.dataCount();
      DKPid pid = p.getPidObject();
      System.out.println("pid string " + pid.pidString());
      System.out.println("Number of Data Items " + numDataItems);
      for (j = 1; j <= numDataItems; j++)
      {
       a = p.getData(j);
       strDataName = p.getDataName(j);
       System.out.println(j + ": Attribute Name " + strDataName );
       System.out.println("type " + p.getDataPropertyByName(j,DK_PROPERTY_TYPE));
       System.out.println("nullable " + p.getDataPropertyByName(j,DK_PROPERTY_NULLABLE));
       if (a instanceof String)
       {
	 System.out.println("   Attribute Value " + a);    
       }
       else if (a instanceof Integer)
       {
        System.out.println("   Attribute Value " + a);    
       }
       else if (a instanceof Short)
       {
        System.out.println("   Attribute Value " + a);    
       }
       else if (a instanceof dkDataObjectBase)
       {
         pDO = (dkDataObjectBase)a;
         if (pDO.protocol() == DK_PDDO)
	 {
          System.out.println("    DKDDO object ");
          pid = ((DKDDO)pDO).getPidObject();
          System.out.println("pid string " + pid.pidString());
	 }
         else if (pDO.protocol() == DK_XDO)
	 {
	  System.out.println("    dkXDO object ");
          pXDO = (dkXDO)pDO;
          pidXDO = (DKPidXDO)pXDO.getPidObject();
          System.out.println("XDO pid string " + pidXDO.pidString());
          // Retrieve and open instance handler for an XDO
	  // pXDO.retrieve();
	  // pXDO.open();
	 }
       }
       else if (a instanceof DKDate)
       {
        System.out.println("   Attribute Value " + a);    
       }
       else if (a instanceof DKTime)
       {
        System.out.println("   Attribute Value " + a);    
       }
       else if (a instanceof DKTimestamp)
       {
        System.out.println("   Attribute Value " + a);    
       }
       else if (a != null) {
	   System.out.println("   Attribute Value " + a.toString());    
       }
       else System.out.println("   Attribute Value is null");    
      }       
     }
    }
    pCur.destroy(); // Finished with the cursor
    System.out.println("query results processed");
    System.out.println("Number of items " + cnt );
    dsJDBC.commit();
    dsJDBC.disconnect();
    System.out.println("datastore disconnected"); 
    dsJDBC.destroy();
    }
    catch (DKException exc)
    {
     try {
     dsJDBC.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
     dsJDBC.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

  }
}

