/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

// sample connect/disconnect to OnDemand

/*
 * Filename       : TConnectOD.java
 * Description    : test DKDatastoreOD for connect and disconnect
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;
import java.lang.*;
import java.util.*;

// TConnectOD class
public class TConnectOD
{
  // Main method
  public static void main(String argv[])
  {
    int num_loops = 1;

      //*** for input parameters

      // everest - libsrv, edms1 uid/pw
      String libSrv = new String(""),     // library server
             userid = new String(""),     //userid
             pw = new String(""),         // pw
             connect_string = new String(""),
             num_loops_string = new String("");

      //--------------------------------------------------------------
      // Checking for input parameters
      //--------------------------------------------------------------
      if (argv.length < 3)
      {
       System.out.println("Invoke Syntax: " );
       System.out.println("  java TConnectOD " +
        "<libSrv> <userid> <pw> <connect string>" );
       return;
      }
      else
      {
       libSrv = argv[0];
       userid = argv[1];
       pw = argv[2];
       if (argv.length > 3)
         connect_string = argv[3];
       if (argv.length > 4 )
       {
         num_loops_string = argv[4];
         num_loops = Integer.parseInt(num_loops_string);
       }
      }

    try
    {
      for (int loop=1; loop<=num_loops; loop++)
      {
        long t = 0;
        DKDatastoreOD dsOD = new DKDatastoreOD();
        String userName = dsOD.userName();
        String dsName = dsOD.datastoreName();
        System.out.println("before connecting to datastore");
        System.out.println("  parameters returned from datastore - user: " +
                           userName + "; dsName: " + dsName);

        System.out.println("connecting to datastore ...");
        t = (new Date()).getTime();
        dsOD.connect(libSrv,userid,pw,connect_string);
        t = (new Date()).getTime() - t;
        System.out.println("Connect elapsed time: " + t + " msec");
        System.out.println("  connection ok");
        System.out.println("  verifying parameters ...");
        System.out.println("    arguments received from command    - user: " +
                           userid + "; library server: " + libSrv);
        userName = dsOD.userName();
        dsName = dsOD.datastoreName();
        System.out.println("    parameters returned from datastore - user: " +
                           userName + "; dsName:         " + dsName);
        dsOD.disconnect();
        System.out.println("disconnecting from the datastore ...");
        userName = dsOD.userName();
        dsName = dsOD.datastoreName();
        System.out.println("  disconnection ok");
        System.out.println("  parameters returned from datastore - user: " +
                           userName + "; dsName: " + dsName);
        System.out.println("Finish loop " + loop);

        dsOD.destroy(); // Finished with the datstore
      } //end for loop
    }
    catch (DKException exc)
    {
      System.out.println("Exception name: " + exc.name());
      System.out.println("Exception message: " + exc.getMessage());
      exc.printStackTrace();
    }
    catch (Exception exc)
    {
      System.out.println("Exception message: " + exc.getMessage());
      exc.printStackTrace();
    }

  }
}

